/***************************************************************************
****************************************************************************
****************************************************************************
*
* FunktrackerGOLD - By Jason Nunn
* Copyright (C) 1996,1998 Jason Nunn
*
* FunktrackerGOLD now comes under the GNU General Public License. Please
* read the COPYING notice in this distribution.
*
* ================================================================
* Sample Editor
*
****************************************************************************
****************************************************************************
***************************************************************************/
#include <curses.h>
#include <unistd.h>
#include <malloc.h>
#include "funktracker_defs.h"
#include "dsp_mixxer.h"
#include "funktracker.h"
#include "funkload.h"
#include "funkgold_misc.h"
#include "funkgold_dir.h"
#include "funkgold_pe.h"
#include "funkgold.h"

double resample_factor = 1;
unsigned char sm_pos_real;
unsigned char sm_pos_hl;
unsigned char sm_pos_hl_old;
unsigned char sm_sd_option;

/***************************************************************************
****************************************************************************
****************************************************************************
*
* Sample editor
*
****************************************************************************
****************************************************************************
***************************************************************************/

/***************************************************************************
* miwi 27/05/96
***************************************************************************/
void sm_display_bg(void)
{
  register int y;
  register int amaxy = maxy - 5;

  display_topbar();

#if 1 /* ZIPIT_Z2 */
  if (MAXX < 79)
  {
  register int x = 0;
  if (MAXX > 62)
    x = 9;
  set_colour(COL_TITLE);
  move(1,0);
  addstr("Sample Editor");
  set_colour_hl(COL_BOX);
  clear_area(2,0,2,MAXX);
  clear_area(amaxy,0,amaxy,MAXX);
  for(y = 0;y < (maxy - 8);y++)
  {
    move(y + 3,2);
    addch(' ');
    move(y + 3,22);
    addch(' ');
    if (x)
    {
      move(y + 3,22+x);
      addch(' ');
    }
    move(y + 3,31+x);
    addch(' ');
    move(y + 3,34+x);
    addch(' ');
    move(y + 3,37+x);
    addch(' ');
    move(y + 3,41+x);
    addch(' ');
    move(y + 3,43+x);
    addch(' ');
    move(y + 3,46+x);
    addch(' ');
    move(y + 3,49+x);
    addch(' ');
    move(y + 3,51+x);
    addch(' ');
  }
  move(2,0);
  addstr("No");
  move(2,3);
  addstr("Sample Name");
  if (x)
  {
    move(2,23);
    addstr("Length");
    move(2,23+x);
  }
  else
  {
    move(2,23-4);
    addstr("Len");
    move(2,23);
  }

  addstr("Start");
  move(2,32+x);
  addstr("Vl");
  move(2,35+x);
  addstr("Bl");
  move(2,38+x);
  addstr("Prt");
  move(2,42+x);
  addch('S');
  move(2,44+x);
  addstr("Vb");
  move(2,47+x);
  addstr("Tr");
  move(2,50+x);
  addch('R');
  move(2,52+x);
  addch('A');

  set_colour(COL_TEXT2);
  y = strlen(song_filename);
  if(y > (MAXX-20)) y = MAXX-20;
  move(1,MAXX - (7 + y));
  addstr("SONG: ");
  addnstr(song_filename,MAXX-20);
  amaxy = maxy - 4;
  move(amaxy,0);
  addstr("Last Note:");
  move(amaxy,30);
  addstr("Octave:");

  return;
  }
else
#endif
  set_colour(COL_TITLE);
  move(1,0);
  addstr("Sample Editor");
  set_colour_hl(COL_BOX);
  clear_area(2,0,2,79);
  clear_area(amaxy,0,amaxy,79);
  for(y = 0;y < (maxy - 8);y++)
  {
    move(y + 3,0);
    addch(' ');
    move(y + 3,3);
    addch(' ');
    move(y + 3,23);
    addstr("  ");
    move(y + 3,33);
    addstr("  ");
    move(y + 3,43);
    addstr("  ");
    move(y + 3,47);
    addstr("  ");
    move(y + 3,51);
    addstr("  ");
    move(y + 3,59);
    addstr("  ");
    move(y + 3,62);
    addstr("  ");
    move(y + 3,67);
    addstr("  ");
    move(y + 3,72);
    addstr("  ");
    move(y + 3,75);
    addstr("  ");
    move(y + 3,78);
    addstr("  ");
  }
  move(2,1);
  addstr("No");
  move(2,4);
  addstr("Sample Name");
  move(2,25);
  addstr("Length");
  move(2,35);
  addstr("Start");
  move(2,45);
  addstr("Vl");
  move(2,49);
  addstr("Bl");
  move(2,53);
  addstr("Port");
  move(2,61);
  addch('S');
  move(2,64);
  addstr("Vib");
  move(2,69);
  addstr("Trm");
  move(2,74);
  addch('R');
  move(2,77);
  addch('A');

  set_colour(COL_TEXT2);
  y = strlen(song_filename);
  if(y > 56) y = 56;
  move(1,80 - (6 + y));
  addstr("SONG: ");
  addnstr(song_filename,56);
  amaxy = maxy - 4;
  move(amaxy,0);
  addstr("Last Note:");
  move(amaxy,30);
  addstr("Octave:");
}

/***************************************************************************
*
***************************************************************************/
void sm_hl_bar(unsigned char pl,unsigned char x)
{
  if((sm_pos_hl == pl) && (sm_sd_option == x))
  {
    set_colour(COL_TITLE);
    attron(A_REVERSE);
  }
  else
  {
    set_colour(COL_TEXT);
    attroff(A_REVERSE);
  }
}

void sm_dis_samentry(unsigned char hlpos)
{
  char bstr[] = "  ";
  char dstr[] = "        ";
  char *wf_str[] = {"Sin","Tri","Sqr","Saw","Rdm"};
  register int sam_no = sm_pos_real + hlpos;


#if 1 /* ZIPIT_Z2 */
  if (MAXX < 79)
  {
  char *wf_st[] = {"Sn","Tr","Sq","Sw","Rn"};
  register int x = 0;
  if (MAXX > 62)
    x = 9;

  set_colour(COL_TEXT);
  attroff(A_REVERSE);
  move(hlpos + 3,0);
  byte2str(bstr,sam_no);
  addstr(bstr);

  sm_hl_bar(hlpos,0);
  move(hlpos + 3,3);
  addnstr(funk_hr_ptr->funk_sb[sam_no].sname,19);

  if (x || (sm_sd_option >0))
  {
    set_colour(COL_TEXT);
    attroff(A_REVERSE);
    move(hlpos + 3,23-9+x);
    dword2str(dstr,funk_hr_ptr->funk_sb[sam_no].length);
    addstr(dstr);
  }

  sm_hl_bar(hlpos,1);
  move(hlpos + 3,23+x);
  dword2str(dstr,funk_hr_ptr->funk_sb[sam_no].start);
  addstr(dstr);

  sm_hl_bar(hlpos,2);
  move(hlpos + 3,32+x);
  byte2str(bstr,funk_hr_ptr->funk_sb[sam_no].volume);
  addstr(bstr);

  sm_hl_bar(hlpos,3);
  move(hlpos + 3,35+x);
  byte2str(bstr,funk_hr_ptr->funk_sb[sam_no].balance);
  addstr(bstr);

  sm_hl_bar(hlpos,4);
  move(hlpos + 3,38+x);
  if((funk_hr_ptr->funk_sb[sam_no].pt_and_sop >> 4))
    addstr("Lin");
  else
    addstr("Crv");

  sm_hl_bar(hlpos,5);
  move(hlpos + 3,42+x);
  addch(nibble_display[funk_hr_ptr->funk_sb[sam_no].pt_and_sop & 0xf]);

  sm_hl_bar(hlpos,6);
  move(hlpos + 3,44+x);
  addstr(wf_st[funk_hr_ptr->funk_sb[sam_no].vv_waveform >> 4]);

  sm_hl_bar(hlpos,7);
  move(hlpos + 3,47+x);
  addstr(wf_st[funk_hr_ptr->funk_sb[sam_no].vv_waveform & 0xf]);

  sm_hl_bar(hlpos,8);
  move(hlpos + 3,50+x);
  addch(nibble_display[funk_hr_ptr->funk_sb[sam_no].rl_and_as >> 4]);

  sm_hl_bar(hlpos,9);
  move(hlpos + 3,52+x);
  addch(nibble_display[funk_hr_ptr->funk_sb[sam_no].rl_and_as & 0xf]);
  return;
  }
  else
#endif
  set_colour(COL_TEXT);
  attroff(A_REVERSE);
  move(hlpos + 3,1);
  byte2str(bstr,sam_no);
  addstr(bstr);

  sm_hl_bar(hlpos,0);
  move(hlpos + 3,4);
  addnstr(funk_hr_ptr->funk_sb[sam_no].sname,19);

  set_colour(COL_TEXT);
  attroff(A_REVERSE);
  move(hlpos + 3,25);
  dword2str(dstr,funk_hr_ptr->funk_sb[sam_no].length);
  addstr(dstr);

  sm_hl_bar(hlpos,1);
  move(hlpos + 3,35);
  dword2str(dstr,funk_hr_ptr->funk_sb[sam_no].start);
  addstr(dstr);

  sm_hl_bar(hlpos,2);
  move(hlpos + 3,45);
  byte2str(bstr,funk_hr_ptr->funk_sb[sam_no].volume);
  addstr(bstr);

  sm_hl_bar(hlpos,3);
  move(hlpos + 3,49);
  byte2str(bstr,funk_hr_ptr->funk_sb[sam_no].balance);
  addstr(bstr);

  sm_hl_bar(hlpos,4);
  move(hlpos + 3,53);
  if((funk_hr_ptr->funk_sb[sam_no].pt_and_sop >> 4))
    addstr("Linear");
  else
    addstr("Curved");

  sm_hl_bar(hlpos,5);
  move(hlpos + 3,61);
  addch(nibble_display[funk_hr_ptr->funk_sb[sam_no].pt_and_sop & 0xf]);

  sm_hl_bar(hlpos,6);
  move(hlpos + 3,64);
  addstr(wf_str[funk_hr_ptr->funk_sb[sam_no].vv_waveform >> 4]);

  sm_hl_bar(hlpos,7);
  move(hlpos + 3,69);
  addstr(wf_str[funk_hr_ptr->funk_sb[sam_no].vv_waveform & 0xf]);

  sm_hl_bar(hlpos,8);
  move(hlpos + 3,74);
  addch(nibble_display[funk_hr_ptr->funk_sb[sam_no].rl_and_as >> 4]);

  sm_hl_bar(hlpos,9);
  move(hlpos + 3,77);
  addch(nibble_display[funk_hr_ptr->funk_sb[sam_no].rl_and_as & 0xf]);
}

/***************************************************************************
* miwi 27/05/96
***************************************************************************/
void sm_display_all(void)
{
  register int sam_no;

  for(sam_no = 0;sam_no < (maxy - 8);sam_no++)
    sm_dis_samentry(sam_no);
  display_oct_no();
  sm_pos_hl_old = sm_pos_hl;
}

void sm_move_hl(void)
{
#if 1 /* ZIPIT_Z2 */
  if (MAXX <= 62)
  {
    sm_display_all();
    return;
  }
#endif
  sm_dis_samentry(sm_pos_hl_old);
  sm_dis_samentry(sm_pos_hl);
  sm_pos_hl_old = sm_pos_hl;
}

/***************************************************************************
* miwi 27/05/96
***************************************************************************/
void sm_cursor_up(void)
{
  if(sm_pos_hl > 0)
  {
    sm_pos_hl--;
    sm_move_hl();
    sm_dis_samentry(sm_pos_hl);
    update_screen();
  }
  else
  {
    if(sm_pos_real > 0) sm_pos_real--;
    sm_display_all();
    update_screen();
  }
}

void sm_cursor_down(void)
{
  if(sm_pos_hl < (maxy - 9))
  {
    sm_pos_hl++;
    sm_move_hl();
    sm_dis_samentry(sm_pos_hl);
    update_screen();
  }
  else
  {
    if(sm_pos_real < ((64 + 8) - maxy)) sm_pos_real++;
    sm_display_all();
    update_screen();
  }
}

/***************************************************************************
*
***************************************************************************/
void sm_edit_sd(void)
{
  register long x;
  char str[20] = "";
  register int sam_no = sm_pos_real + sm_pos_hl;

  switch(sm_sd_option)
  {
    case 0:
      get_string(3 + sm_pos_hl,4,str,19);
      for(x = 0;x < 19;x++)
      if(str[x])
        funk_hr_ptr->funk_sb[sam_no].sname[x] = str[x];
      else
        funk_hr_ptr->funk_sb[sam_no].sname[x] = 32;
      break;
    case 1:
      get_string(3 + sm_pos_hl,35,str,8);
      funk_hr_ptr->funk_sb[sam_no].start = hex2longn(str);
      break;
    case 2:
      get_string(3 + sm_pos_hl,45,str,2);
      funk_hr_ptr->funk_sb[sam_no].volume = hex2charn(str);
      break;
    case 3:
      get_string(3 + sm_pos_hl,49,str,2);
      funk_hr_ptr->funk_sb[sam_no].balance = hex2charn(str);
      break;
    case 4:
      funk_hr_ptr->funk_sb[sam_no].pt_and_sop ^= 0x10;
      break;
    case 5:
      get_string(3 + sm_pos_hl,61,str,1);
      funk_hr_ptr->funk_sb[sam_no].pt_and_sop &= 0xf0;
      funk_hr_ptr->funk_sb[sam_no].pt_and_sop |= hex2nibn(str) & 0xf;
      break;
    case 6:
      x = (funk_hr_ptr->funk_sb[sam_no].vv_waveform >> 4) + 1;
      if(x > 4)
        x = 0;
      funk_hr_ptr->funk_sb[sam_no].vv_waveform &= 0x0f;
      funk_hr_ptr->funk_sb[sam_no].vv_waveform |= x << 4;
      break;
    case 7:
      x = (funk_hr_ptr->funk_sb[sam_no].vv_waveform & 0xf) + 1;
      if(x > 4)
        x = 0;
      funk_hr_ptr->funk_sb[sam_no].vv_waveform &= 0xf0;
      funk_hr_ptr->funk_sb[sam_no].vv_waveform |= x & 0xf;
      break;
    case 8:
      get_string(3 + sm_pos_hl,74,str,1);
      funk_hr_ptr->funk_sb[sam_no].rl_and_as &= 0x0f;
      funk_hr_ptr->funk_sb[sam_no].rl_and_as |= hex2nibn(str) << 4;
      break;
    case 9:
      get_string(3 + sm_pos_hl,77,str,1);
      funk_hr_ptr->funk_sb[sam_no].rl_and_as &= 0xf0;
      funk_hr_ptr->funk_sb[sam_no].rl_and_as |=  hex2nibn(str) & 0xf;
      break;
  }
  sm_dis_samentry(sm_pos_hl);
  update_screen();
  ch = ' ';
}

/***************************************************************************
*
***************************************************************************/
void sm_insert_sam(void)
{
  register int x,sam_no = sm_pos_real + sm_pos_hl;
  for(x = 0x3f;x > sam_no;x--)
  {
    memcpy(&funk_hr_ptr->funk_sb[x],&funk_hr_ptr->funk_sb[x - 1],sizeof(tfunk_sb));
    funk_sam_ptrs[x] = funk_sam_ptrs[x - 1];
  }
  clear_sam_entry(&funk_hr_ptr->funk_sb[x]);
  free(funk_sam_ptrs[x]);
  funk_sam_ptrs[x] = NULL;
  sm_display_all();
  update_screen();
}

void sm_delete_sam(void)
{
  register int x,sam_no = sm_pos_real + sm_pos_hl;
  free(funk_sam_ptrs[sam_no]);
  for(x = sam_no;x < 0x3f;x++)
  {
    memcpy(&funk_hr_ptr->funk_sb[x],&funk_hr_ptr->funk_sb[x + 1],sizeof(tfunk_sb));
    funk_sam_ptrs[x] = funk_sam_ptrs[x + 1];
  }
  clear_sam_entry(&funk_hr_ptr->funk_sb[0x3f]);
  funk_sam_ptrs[0x3f] = NULL;
  sm_display_all();
  update_screen();
}

/***************************************************************************
*
***************************************************************************/
void sm_main(void)
{
  register int nv;

  switch(ch)
  {
#if 1 /* ZIPIT_Z2 */
    case FC_TAB:
#endif
    case FC_GOTO_SEQ_EDIT:
      edit_mode = EM_SEQUENCE;
      main_editor_dis_bg();
      break;
    case FC_GOTO_PAT_EDIT:
      edit_mode = EM_PATTERN;
      main_editor_dis_bg();
      break;
    case FC_SM_ED_ATTR:
      sm_edit_sd();
      break;
    case FC_ARROW_UP:
      sm_cursor_up();
      break;
    case FC_ARROW_DN:
      sm_cursor_down();
      break;
    case FC_ARROW_LEFT:
      if(sm_sd_option > 0) sm_sd_option--;
#if 1 /* ZIPIT_Z2 */
      if (MAXX <= 62)
        sm_display_all();
      else
#endif
      sm_dis_samentry(sm_pos_hl);
      update_screen();
      break;
    case FC_ARROW_RIGHT:
      if(sm_sd_option < 9) sm_sd_option++;
#if 1 /* ZIPIT_Z2 */
      if (MAXX <= 62)
        sm_display_all();
      else
#endif
      sm_dis_samentry(sm_pos_hl);
      update_screen();
      break;
    case FC_SM_LOAD_SAM:
      if(get_sam_file_name(sample_directory,&sam_fpos_real,&sam_fpos_hl,
        &sam_fpos_hl_old,sam_filename) != -1)
      {
        if(chdir(sample_directory) == -1)
          ferr_message("Couldn't locate sample directory.");
        else
        {
          load_sample(sm_pos_real + sm_pos_hl,sam_filename,resample_factor);
          if(ferr_val != FERR_OK)
            ferr_message(ferr_messages[ferr_val]);
        }
      }
      main_editor_dis_bg();
      break;
    case FC_DEL_ENTRY:
      sm_delete_sam();
      break;
    case FC_INS_ENTRY:
      sm_insert_sam();
      break;
    case FC_DEC_OCT:
      dec_oct_no();
      break;
    case FC_INC_OCT:
      inc_oct_no();
      break;
    default:
      global_keys();
      break;
  }
  if((nv = mus_kb_input()) != -1)
  {
    register int period = nv + (pe_octave_no * 12);
    move((maxy - 4),10);
    addstr(note_display[period]);
    update_screen();
    play_slot(period);
  }
}
